<script>
	import { onMount } from 'svelte';

	/**
	 * @type {number}
	 */
	export let amount;

	let formatter = new Intl.NumberFormat('fr-FR', {
		minimumFractionDigits: 2,
		maximumFractionDigits: 2
	});
	/**
	 * @param {number} n
	 */
	function formatNumber(n) {
		let str = formatter.format(n);
		let arr = str.split('');
		let newTarget = [];
		for (let i = 0; i < arr.length; i++) {
			if (arr[i] === ',') {
				newTarget.push(10);
			} else if (/\s/.test(arr[i])) {
				newTarget.push(11);
			} else {
				newTarget.push(+arr[i]);
			}
		}
		return newTarget;
	}
</script>

<div class="flex flex-row mr-1 red-hat justify-end">
	{#each formatNumber(amount / 100) ?? [] as digit}
		<span class="smart-countdown font-mono mt-1">
			<span style="--value:{digit};"></span>
		</span>
	{/each}
</div>

<style>
	@import url('https://fonts.googleapis.com/css2?family=Red+Hat+Mono:wght@700&display=swap');
	.red-hat {
		font-family: 'Red Hat Mono', monospace;
		font-optical-sizing: auto;
		font-weight: 700;
		font-style: normal;
		font-size: 1em;
	}
	.smart-countdown {
		line-height: 1em;
	}
	.smart-countdown {
		display: inline-flex;
	}
	.smart-countdown > * {
		height: 1em;
		display: inline-block;
		overflow-y: hidden;
	}
	.smart-countdown > *:before {
		position: relative;
		content: '0\A 1\A 2\A 3\A 4\A 5\A 6\A 7\A 8\A 9\A ,\A  \A';
		white-space: pre;
		top: calc(var(--value) * -1em);
		text-align: center;
		transition: all 1s cubic-bezier(1, 0, 0, 1);
	}
</style>
